/* win32.c - this file is part of $PROJECT_NAME_HERE$
 *
 * Copyright (C) 2006 Wolfgang Sourdeau
 *
 * Author: Wolfgang Sourdeau <Wolfgang@Contre.COM>
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This file is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <windows.h>

LRESULT CALLBACK __declspec(dllexport) KeyboardFuncLL (int nCode, WPARAM wParam, PKBDLLHOOKSTRUCT lParam );

static HANDLE hInstance; // Global instance handle de la DLL
int __declspec(dllexport) _keyPtr __attribute__((section ("shared"), shared)) = 0;

// Filter Function Addresses
FARPROC lpfnHookProcs = (FARPROC) KeyboardFuncLL;
// Hook Handles
HHOOK hhookHooks;

//
// DllMain de la DLL
//
BOOL WINAPI DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
  if (dwReason == DLL_PROCESS_ATTACH)
    {
      hInstance = hModule;
      printf ("attach\n");
      fflush (stdout);
    }

  return 1;
}

LRESULT CALLBACK __declspec(dllexport) KeyboardFunc (int nCode, WPARAM wParam, LPARAM lParam )
{
  if ( nCode >= 0 )
    _keyPtr = wParam;

  return( CallNextHookEx(hhookHooks, nCode, wParam, lParam));
}


LRESULT CALLBACK __declspec(dllexport)
KeyboardFuncLL (int nCode, WPARAM wParam, PKBDLLHOOKSTRUCT lParam )
{
  if ( nCode >= 0 )
    _keyPtr = lParam->vkCode;

  return( CallNextHookEx(hhookHooks, nCode, wParam, lParam));
}


//
// Installe/Supprime le Hook clavier
//
int __declspec(dllexport) InstallFilter ( int nCode )
{
  _keyPtr = 0;
  if (nCode)
    hhookHooks = SetWindowsHookEx (WH_KEYBOARD_LL, (HOOKPROC) lpfnHookProcs,
                                   hInstance, 0L);
  else
    UnhookWindowsHookEx (hhookHooks);

  return 0;
}
